#include <Wire.h> 
#include <SPI.h>
#include <Ethernet.h>
#include <MsTimer2.h>
#include <EEPROM2.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 20, 4);

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};
IPAddress ip(192, 168, 0, 97);

// Initialize the Ethernet server library
// with the IP address and port you want to use
// (port 80 is default for HTTP):
EthernetServer server(80);

volatile unsigned int state = 3200;
volatile unsigned int blinkMin = 0;
volatile unsigned int tm = 0;
uint32_t kWh = 0;
unsigned int Wm = 0;
 
void setup(){
    // Open serial communications and wait for port to open:
  Serial.begin(9600);
    // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
    
   //*Для синхронизации показаний электросчетчика с Ардуиной раскомментировать 2 строчки ниже
   //*в строку kWh = 0; вместо нуля подставить текущее значение счетчика
   //*загрузить скетч, потом закомментировать эти 2 строки и еще раз загрузить скетч
 
   //kWh = 0;  
   //EEPROM_write(1, kWh);
   
  lcd.init();
  lcd.backlight();
   
  pinMode(2, INPUT_PULLUP); 

  EEPROM_read(1, kWh); //читаем показания электросчетчика из EEPROM
 
  attachInterrupt(0, blink, RISING);  

  MsTimer2::set(60000, MsTimer);  
  MsTimer2::start();
  
}
 
void loop(){
  
   //выводим информацию на экран
   lcd.setCursor(0, 0);
   lcd.print(kWh); 
   lcd.print(" kWh         "); 
   lcd.setCursor(0, 1);
   lcd.print(state); 
   Serial.println(kWh);
   delay(100);
   
   
     // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
          client.println("Refresh: 5");  // refresh the page automatically every 5 sec
          client.println();
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");
          client.println("<meta http-equiv='content-type' content='text/html; charset=UTF-8'>");
          client.println("<title>ЭЛЕКТРОСЧЕТЧИК</title>");

                    client.print(kWh);
                    client.print(" кВт*ч<br /><br />");
                    client.print(state);

          client.println("</html>");
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disconnected");
  }
}

void MsTimer(){
  Wm = blinkMin;  
  blinkMin = 0;
}
 
void blink(){
  state--;
  if(state == 0 || state > 3200){ 
     kWh++;
     EEPROM_write(1, kWh); //Записываем текущее показание электросчетчика
     state = 3200; 
   } 
  blinkMin++;
}
